// %flair:license{
// This file is part of the Flair framework distributed under the
// CECILL-C License, Version 1.0.
// %flair:license}
//  created:    2016/11/16
//  filename:   Semaphore.cpp
//
//  author:     Thomas Fuhrmann
//              Copyright Heudiasyc UMR UTC/CNRS 7253
//
//  version:    $Id: $
//
//  purpose:    Class defining a semaphore
//
//
/*********************************************************************/

#include "Semaphore.h"
#include "Semaphore_impl.h"

using std::string;

namespace flair {
namespace core {

Semaphore::Semaphore(const Object *parent, uint32_t initialValue, string name)
    : Object(parent, name, "semaphore") {
  pimpl_ = new Semaphore_impl(this, initialValue);
}

Semaphore::~Semaphore() { delete pimpl_; }

void Semaphore::GetSemaphore(void) const { pimpl_->GetSemaphore(); }

void Semaphore::ReleaseSemaphore(void) const { pimpl_->ReleaseSemaphore(); }

} // end namespace core
} // end namespace flair
